#include <tigcclib.h>
#define WAIT 2
#define WAIT2 5
#define full &(SCR_RECT){{0,0,159,99}}
#define RECT(x1,x2,y1,y2) &(SCR_RECT){{x1,x2,y1,y2}}

/* Fast pixle access thanks to TICT */
#define PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define PIXADDR(p,x,y)  (((unsigned char*)(p))+PIXOFFSET(x,y))
#define PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))
#define GETPIX(p,x,y)   (!(!(*PIXADDR(p,x,y) & PIXMASK(x))))
#define SETPIX(p,x,y)   (*PIXADDR(p,x,y) |=  PIXMASK(x))
#define CLRPIX(p,x,y)   (*PIXADDR(p,x,y) &= ~PIXMASK(x))
#define XORPIX(p,x,y)   (*PIXADDR(p,x,y) ^=  PIXMASK(x))

enum keys {Eenter=13,Eback=257,Eclear=263,Eescape,Eapps,Emode,Ef1=268,Ef2,Ef3,Ef4,Ef5,Ef6,Ef7,Ef8,Ehome=277,Ecatalog,Eup=337,Eleft,Eleftup,Edown,Eupdown,Eleftdown,Eleftupdown,Eright,Eupright,Eleftright,Eleftupright,Erightdown,Euprightdown,Eleftdownright,Euprightleftdown,E2nddimondalpha,Edimondalpha=380,E2nddimondshiftalpha=384,E2ndup=4433,E2ndleft,E2ndleftup,E2nddown,E2ndupdown,E2ndleftdown,E2ndrightupdown,E2ndright,E2ndupright,E2ndleftright,E2ndleftupright,E2ndrightdown,E2nduprightdown,E2ndleftdownright,E2nduprightleftdown,Edimondenter=16397,Edimondback=16641,Edimondclear=16647,Edimondescape,Edimondapps,Edimondmode,Edimondup=16721,Edimondleft,Edimondleftup,Edimonddown,Edimondupdown,Edimondleftdown,Edimondrightupdown,Edimondright,Edimondupright,Edimondleftright,Edimondleftupright,Edimondrightdown,Edimonduprightdown,Edimondleftdownright,Edimonduprightleftdown};
volatile unsigned int tick,tock;
volatile unsigned char sp;
INT_HANDLER oldint5=NULL;
DEFINE_INT_HANDLER (myint5handler) {
    tick++;
	tock++;
	if (tick>WAIT) {
		tick=0;
		sp++;
		if (sp==8)
			sp=0;
	}
	ExecuteHandler(oldint5);
}
const char *predefs[]=   {"Conway","2x2",  "Amoeba", "Assimilation","Coral","Day&Night","Flakes","Gnarl","HighLife","Maze","Maze w/ Mice","Replicator","Seeds","Walled Cities"};
unsigned int pdvs[14][2]={{12,8},  {38,72},{298,168},{240,56},      {496,8},{472,456},  {511,8}, {2,2},  {12,72},   {62,8},{62,136},      {170,170},   {0,4},  {60,496}};
unsigned short ico[8][13]={{0x0000,0x03c0,0x3420,0x4420,0x4300,0x4860,0x4890,0x3090,0x0610,0x2110,0x2160,0x1e00,0x0000},{0x0180,0x03c0,0x2da0,0x4c00,0xe660,0xe5e0,0x4890,0x3d38,0x3338,0x0190,0x2da0,0x1e00,0x0c00},{0x0240,0x0400,0x1800,0x81a0,0x1120,0x1d10,0x8008,0x45c0,0x2440,0x2c08,0x00c0,0x0100,0x1200},{0x0000,0x0c00,0x0800,0x19c0,0x1170,0x1a10,0x0500,0x42c0,0x7440,0x1cc0,0x0080,0x0180,0x0000},{0x0000,0x0c00,0x0080,0x1940,0x2750,0x1f90,0x0d80,0x4fc0,0x5720,0x14c0,0x0800,0x0180,0x0000},{0x0000,0x0000,0x1480,0x1d60,0x2040,0x1060,0x0000,0x3040,0x1020,0x35c0,0x0940,0x0000,0x0000},{0x0000,0x0000,0x16c0,0x3660,0x2000,0x0060,0x3060,0x3000,0x0020,0x3360,0x1b40,0x0000,0x0000},{0x0000,0x0000,0x37e0,0x37e0,0x3000,0x3060,0x3060,0x3060,0x0060,0x3f60,0x3f60,0x0000,0x0000}};
unsigned char edit(),nums[16000],sh,sw,sx,sy;
unsigned int rule[2];
void about(),count(),*cs,GenNewScreen(),run(),*s,setup();
void _main(void) {
	int k;
	unsigned char a,b,osp;
	if (!(s=malloc(LCD_SIZE)))
		return;
	memset(s,0,LCD_SIZE);
	rule[0]=0b000001100; // survival
	rule[1]=0b000001000; // birth
	sh=40;
	sw=40;
	sp=0;
	tick=0;
	k=0;
	a=0;
	oldint5=GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_5,myint5handler);
	while (k!=Eescape) {
		clrscr();
		FontSetSys(F_8x10);
		DrawStr(0,2,"The Game of Life!",A_NORMAL);
		DrawStr(17,15,"Start",A_NORMAL);
		DrawStr(17,30,"Rules",A_NORMAL);
		DrawStr(17,45,"About",A_NORMAL);
		DrawStr(17,60,"Exit",A_NORMAL);
		Sprite16(2,13+15*a,13,ico[sp],LCD_MEM,SPRT_XOR);
		k=0;
		osp=sp;
		while (!k) {
			if (osp!=sp) {
				Sprite16(2,13+15*a,13,ico[osp],LCD_MEM,SPRT_XOR);
				Sprite16(2,13+15*a,13,ico[sp],LCD_MEM,SPRT_XOR);
				osp=sp;
			}
			if (kbhit()) {
				k=ngetchx();
				switch (k) {
					case Eup:
						Sprite16(2,13+15*a,13,ico[sp],LCD_MEM,SPRT_XOR);
						if (a==0)
							a=4;
						a--;
						Sprite16(2,13+15*a,13,ico[sp],LCD_MEM,SPRT_XOR);
						k=0;
						break;
					case Edown:
						Sprite16(2,13+15*a,13,ico[sp],LCD_MEM,SPRT_XOR);
						a++;
						if (a==4)
							a=0;
						Sprite16(2,13+15*a,13,ico[sp],LCD_MEM,SPRT_XOR);
						k=0;
						break;
					case Eenter:
						switch (a) {
							case 0:
								while ((b=edit())) {
									if (b==1)
										run();
								}
								break;
							case 1:
								setup();
								break;
							case 2:about();break;
							case 3:k=Eescape;break;
						}
						break;
					case Eescape:break;
					default:k=0;break;
				}
			}
		}
	}
	SetIntVec(AUTO_INT_5,oldint5);
	free(s);
}
unsigned char edit() {
	int k;
	unsigned char a,aa,b,bb,bsx,bsy,c,pxs;
	pxs=100/sh;
	if (160/sw<pxs)
		pxs=160/sw;
	sx=(160-sw)/2;
	sy=(100-sh)/2;
	bsx=(160-sw*pxs)/2;
	bsy=(100-sh*pxs)/2;
	clrscr();
	ScrRectFill(full,full,A_NORMAL);
	ScrRectFill(RECT(bsx,bsy,bsx+sw*pxs-1,bsy+sh*pxs-1),full,A_REVERSE);
	for (a=0;a<sh;a++) {
		for (b=0;b<sw;b++) {
			if (GETPIX(s,(b+sx),(a+sy)))
				ScrRectFill(RECT(bsx+pxs*b,bsy+pxs*a,bsx+pxs*b+pxs-1,bsy+pxs*a+pxs-1),full,A_NORMAL);
		}
	}
	a=0;
	b=0;
	c=0;
	k=0;
	tock=WAIT2;
	while (k!=Ef1&&k!=Eescape) {
		if (tock>=WAIT2) {
			ScrRectFill(RECT(bsx+pxs*b,bsy+pxs*a,bsx+pxs*b+pxs-1,bsy+pxs*a+pxs-1),full,A_XOR);
			c=!c;
			tock=0;
		}
		if (kbhit()) {
			k=ngetchx();
			if (c)
				ScrRectFill(RECT(bsx+pxs*b,bsy+pxs*a,bsx+pxs*b+pxs-1,bsy+pxs*a+pxs-1),full,A_XOR);
			switch (k) {
				case Eup:
					if (a==0)
						a=sh;
					a--;
					break;
				case E2ndup:
					if (a<10)
						a+=sh;
					a-=10;
					break;
				case Edimondup:
					if (sh>1)
						sh--;
					return 2;
					break;
				case Edown:
					a++;
					if (a==sh)
						a=0;
					break;
				case E2nddown:
					a+=10;
					if (a>=sh)
						a-=sh;
					break;
				case Edimonddown:
					if (sh<100)
						sh++;
					return 2;
					break;
				case Eleft:
					if (b==0)
						b=sw;
					b--;
					break;
				case E2ndleft:
					if (b<10)
						b+=sw;
					b-=10;
					break;
				case Edimondleft:
					if (sw>1)
						sw--;
					return 2;
					break;
				case Eright:
					b++;
					if (b==sw)
						b=0;
					break;
				case E2ndright:
					b+=10;
					if (b>=sw)
						b-=sw;
					break;
				case Edimondright:
					if (sw<160)
						sw++;
					return 2;
					break;
				case Ef2:
					PortSet(s,239,127);
					ScrRectFill(RECT(sx,sy,sx+sw-1,sy+sh-1),full,A_REVERSE);
					PortRestore();
					ScrRectFill(RECT(bsx,bsy,bsx+sw*pxs-1,bsy+sh*pxs-1),full,A_REVERSE);
					break;
				case Ef3 ... Ef5:
					for (aa=0;aa<sh;aa++) {
						for (bb=0;bb<sw;bb++) {
							if ((rand()&3)<k-Ef2) {
								SETPIX(s,(bb+sx),(aa+sy));
								ScrRectFill(RECT(bsx+pxs*bb,bsy+pxs*aa,bsx+pxs*bb+pxs-1,bsy+pxs*aa+pxs-1),full,A_NORMAL);
							}
							else {
								CLRPIX(s,(bb+sx),(aa+sy));
								ScrRectFill(RECT(bsx+pxs*bb,bsy+pxs*aa,bsx+pxs*bb+pxs-1,bsy+pxs*aa+pxs-1),full,A_REVERSE);
							}
						}
					}
					break;
				case Eenter:
					ScrRectFill(RECT(bsx+pxs*b,bsy+pxs*a,bsx+pxs*b+pxs-1,bsy+pxs*a+pxs-1),full,A_XOR);
					XORPIX(s,(b+sx),(a+sy));
					break;
			}
			if (c)
				ScrRectFill(RECT(bsx+pxs*b,bsy+pxs*a,bsx+pxs*b+pxs-1,bsy+pxs*a+pxs-1),full,A_XOR);
		}
	}
	if (k==Eescape)
		return 0;
	return 1;
}
void about() {
	clrscr();
	FontSetSys(F_8x10);
	printf("The Game of Life!\n");
	FontSetSys(F_6x8);
	printf("Written by Andrew Vauter\n\nThanks to:\n");
	FontSetSys(F_4x6);
	printf("John Conway, for inventing the game.\nMirek's Cellebration, for the preloaded rules.\nTI Chess Team, for the fast pixle access code.");
	ngetchx();
	clrscr();
	FontSetSys(F_8x10);
	printf("Controlls\n\n");
	FontSetSys(F_6x8);
	printf("In Simulator\n  Arrows - Move cursor\n  w/2nd  - Move faster\n  w/%c    - Resize universe\n  F1     - Simulate\n  F2     - Clear\n  F3     - Random 25%%\n  F4     - Random 50%%\n  F5     - Random 75%%",127);
	ngetchx();
	clrscr();
	printf("Controlls\n\n");
	FontSetSys(F_6x8);
	printf("In Editor\n  F1 - Stop simulation\n  F2 - Show one step\n  F3 - Run Simplation");
	ngetchx();
}
void count() {
	unsigned char c,r;
	memset(nums,0,sh*sw);
	for (r=sy;r<sy+sh;r++) {
		for (c=sx;c<sx+sw;c++) {
			if (GETPIX(LCD_MEM,c,r)) {
				if (r-sy) {
					if (c-sx)
						nums[sw*(r-sy-1)+(c-sx-1)]++;
					nums[sw*(r-sy-1)+(c-sx)]++;
					if (c-sx<sw-1)
						nums[sw*(r-sy-1)+(c-sx+1)]++;
				}
				if (c-sx)
					nums[sw*(r-sy)+(c-sx-1)]++;
				if (c-sx<sw-1)
					nums[sw*(r-sy)+(c-sx+1)]++;
				if (r-sy<sh-1) {
					if (c-sx)
						nums[sw*(r-sy+1)+(c-sx-1)]++;
					nums[sw*(r-sy+1)+(c-sx)]++;
					if (c-sx<sw-1)
						nums[sw*(r-sy+1)+(c-sx+1)]++;
				}
			}
		}
	}
}
void GenNewScreen() {
	unsigned char c,r;
	count();
	for (r=sy;r<sy+sh;r++) {
		for (c=sx;c<sx+sw;c++) {
			if (GETPIX(cs,c,r)) {
				if (!(rule[0]&(1<<nums[sw*(r-sy)+c-sx])))
					CLRPIX(cs,c,r);
			}
			else {
				if (rule[1]&(1<<nums[sw*(r-sy)+c-sx]))
					SETPIX(cs,c,r);
			}
		}
	}
	memcpy(LCD_MEM,s,LCD_SIZE);
}
void run() {
	int k;
	unsigned char go;
	PortSet(s,239,127);
	if (sx)
		ScrRectFill(RECT(0,0,sx-1,99),full,A_NORMAL);
	if (sy)
		ScrRectFill(RECT(0,0,159,sy-1),full,A_NORMAL);
	if (sx+sw<160)
		ScrRectFill(RECT(sx+sw,0,159,99),full,A_NORMAL);
	if (sy+sh)
		ScrRectFill(RECT(0,sy+sh,159,99),full,A_NORMAL);
	memcpy(LCD_MEM,s,LCD_SIZE);
	cs=s;
	k=0;
	go=0;
	while (k!=Eescape) {
		if (kbhit()||!go) {
			do k=ngetchx();while (!(go||k==Ef2||k==Ef3||k==Eescape));
			switch (k) {
				case Ef2:
				case Ef1:go=0;break;
				case Ef3:go=1;break;
			}
		}
		if (k!=Eescape)
			GenNewScreen();
	}
	if (sx)
		ScrRectFill(RECT(0,0,sx-1,99),full,A_REVERSE);
	if (sy)
		ScrRectFill(RECT(0,0,159,sy-1),full,A_REVERSE);
	if (sx+sw<160)
		ScrRectFill(RECT(sx+sw,0,159,99),full,A_REVERSE);
	if (sy+sh)
		ScrRectFill(RECT(0,sy+sh,159,99),full,A_REVERSE);
	PortRestore();
	cs=LCD_MEM;
}
void setup() {
	unsigned char a,b,c;
	int k;
	k=0;
	while (k!=Eescape) {
		clrscr();
		FontSetSys(F_6x8);
		printf("Rules\nSurvive\n0  1  2  3  4  5  6  7  8\nBirth\n0  1  2  3  4  5  6  7  8\nPredefined\n\nBack\n\n");
		FontSetSys(F_4x6);
		printf("\nSee Readme for discriptions of unique\nproperties of preloaded rules.");
		for (a=0;a<9;a++) {
			ScrRectFill(RECT(8+18*a,17,12+18*a,21),full,A_NORMAL);
			if (!(rule[0]&(1<<a)))
				ScrRectFill(RECT(9+18*a,18,11+18*a,20),full,A_REVERSE);
			ScrRectFill(RECT(8+18*a,33,12+18*a,37),full,A_NORMAL);
			if (!(rule[1]&(1<<a)))
				ScrRectFill(RECT(9+18*a,34,11+18*a,36),full,A_REVERSE);
		}
		a=0;
		while (k!=Eescape) {
			switch (a) {
				case 0:
				case 1:
					b=0;
					while (a<2&&k!=Eescape) {
						ScrRectFill(RECT(18*b,16+16*a,5+18*b,23+16*a),full,A_XOR);
						k=ngetchx();
						ScrRectFill(RECT(18*b,16+16*a,5+18*b,23+16*a),full,A_XOR);
						switch (k) {
							case Eenter:
								ScrRectFill(RECT(9+18*b,18+16*a,11+18*b,20+16*a),full,A_XOR);
								if (rule[a]&(1<<b))
									rule[a]-=1<<b;
								else
									rule[a]+=1<<b;
								break;
							case Eright:
								b++;
								if (b==9)
									b=0;
								break;
							case Eleft:
								if (b==0)
									b=9;
								b--;
								break;
							case Eup:
								if (a==0)
									a=4;
								a--;
								break;
							case Edown:
								a++;
								break;
						}
					}
					break;
				case 2:
					while (a==2&&k!=Eescape) {
						ScrRectFill(RECT(0,40,59,47),full,A_XOR);
						k=ngetchx();
						ScrRectFill(RECT(0,40,59,47),full,A_XOR);
						switch (k) {
							case Eup:a--;break;
							case Edown:a++;break;
							case Eenter:
								b=0;
								k=0;
								while (k!=Eenter&&k!=Eescape&&a==2) {
									ScrRectFill(RECT(63,40,159,47),full,A_REVERSE);
									FontSetSys(F_6x8);
									printf_xy(63,40,"%c%-13s%c",17,predefs[b],18);
									rule[0]=pdvs[b][0];
									rule[1]=pdvs[b][1];
									for (c=0;c<9;c++) {
										if (rule[0]&(1<<c))
											ScrRectFill(RECT(9+18*c,18,11+18*c,20),full,A_NORMAL);
										else
											ScrRectFill(RECT(9+18*c,18,11+18*c,20),full,A_REVERSE);
										if (rule[1]&(1<<c))
											ScrRectFill(RECT(9+18*c,34,11+18*c,36),full,A_NORMAL);
										else
											ScrRectFill(RECT(9+18*c,34,11+18*c,36),full,A_REVERSE);
									}
									k=ngetchx();
									switch (k) {
										case Eup:a--;break;
										case Edown:a++;break;
										case Eleft:
											if (b==0)
												b=14;
											b--;
											break;
										case Eright:
											b++;
											if (b==14)
												b=0;
											break;
									}
								}
								ScrRectFill(RECT(63,40,159,47),full,A_REVERSE);
								break;
						}
					}
					break;
				case 3:
					while (k!=Eescape&&a==3) {
						ScrRectFill(RECT(0,56,23,63),full,A_XOR);
						k=ngetchx();
						ScrRectFill(RECT(0,56,23,63),full,A_XOR);
						switch (k) {
							case Eenter:k=Eescape;break;
							case Eup:a--;break;
							case Edown:a=0;break;
						}
					}
					break;
			}
		}
	}
}
